            subroutine RiSolve(F_Y          [Reference],
     *                         I_Param      [Reference],
     *                         Param_Model  [Reference],
     *                         F_Risolv     [Reference],
     *                         I_Risolv     [Reference],
     *                         H_Risolv     [Reference],
     *                         YY_Risolv    [Reference],
     *                         U1_Risolv    [Reference],
     *                         U2_Risolv    [Reference])
c 
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      include 'max_dimension.fi' ! NEQ -  
               
	integer*4 I_Param(0:20)    !  
	real*8    F_Y(0:NEQ+1)     !    
	
	integer*4 I_Risolv(0:20)
 	real*8    F_Risolv(0:20)
 	
	real*8    H_Risolv (0:NEQ+1)! H - .   
	                            !  
	real*8    YY_Risolv(0:NEQ+1)! YY -    
	
	real*8    U1_Risolv(0:NEQ)  ! U1     U1,U2 -   
	real*8    U2_Risolv(0:NEQ)  ! U2     
	
	include 'Param_common.fi'   !  

	real*8 Param_Model(1:Nparam)
	common /W_Ypositive/ I_Ypositive !   
      REAL*8 U(NEQ+1), Ystep(I_Risolv(13),NEQ+4),
     *       HB(I_Risolv(11)*2),ZB(I_Risolv(11)*2)
      
      REAL*8    FM(Nparam,NEQ) !     
      DIMENSION NB(I_Risolv(11)*2)
c
      COMMON /ADD_R/    S(Nparam)
      COMMON /Par_Mod/  S0(Nparam)
      
      REAL*8 YBIF(I_Risolv(12),NEQ+2)
      REAL*8 YQS (I_Risolv(12),NEQ+2)
      common /bifur_turn_steps/ Nbif, Nturn, Nstep
c
      include 'RiSolve_DLLEXPORT.fi'
!DEC$ IF DEFINED (make_DLL)
      include 'RiSolve_dll.fi'
!DEC$ ENDIF      
c
c-----------------------------------------------------------------------
c  runtime error     
      open (unit=32, mode='write', file='error.DAT', status='unknown')
      write(32,*) ' '
c      
c     Basic data input 
c
      I_Ypositive=I_Param(2)
	Nalpha=I_Risolv(1)    ! Nalpha -  
	NDIM=NEQ
	NPAR=Nalpha
c
c     common blockc
      p(:)=Param_Model(:)
          DO I=1,Nparam
          S(i)=p(i)
	    S0(i)=p(i)
          END DO
c
c     Constants
c
      QMIN= F_Risolv(1)     ! QMIN
      QMAX= F_Risolv(2)     ! QMAX
      HSTEP=F_Risolv(3)     ! HSTEP
      QSOLV=F_Risolv(4)     ! qsolv = alpha
      H00=  F_Risolv(5)     ! Hpar

         DO J=1,NDIM
         U(J)=F_Y(J) ! x(i)
         END DO

      NP1=NDIM+1
      U(NP1)=S(NPAR)
c
c     Standard data input   . 144
      IRARAM=  I_Risolv(2)    ! IPARAM=0
      LIMIT=   I_Risolv(4)    ! LIMIT=3
      LIMIT0=  I_Risolv(5)    ! LIMIT0=5
      IPREDICT=I_Risolv(6)    ! IPREDICT=3
      ACCEL=   F_Risolv(6)    ! ACCEL=1.2
      NDEX=    I_Risolv(7)    ! NDEX=NEQ+1
      EXACT=   F_Risolv(7)    ! EXACT=1.e-9
      EMIN=    F_Risolv(8)    ! EMIN=1.e-13
      EMAX=    F_Risolv(9)    ! EMAX=1.
      STAB=    F_Risolv(10)   ! STAB=1.e+25
      
      Nbif =I_Risolv(11)
	Nturn=I_Risolv(12)
	Nstep=I_Risolv(13)
 
      NEND=Nstep
 
      H_Risolv(NP1)=H00

c*********************************************************************
      CALL SNEQP(NDIM,NDEX,IPARAM,NEND,limit,limit0,
     *           ipredict,hstep,accel,exact,emin,emax,
     *           NPAR,LIMSTEP,KBIF,ISOLV,QSOLV,QMIN,QMAX,
     *           STAB,U(1:NP1),
     *           H_Risolv (1:NP1), YY_Risolv(1:NP1),
     *           U1_Risolv(1:NEQ), U2_Risolv(1:NEQ),
     *           FM,Ystep,ifail,
     *           YQS,YBIF)
c
c 
      CALL error('Risolve')
c            
      I_Risolv(20)=ifail
      	  if (ifail.gt.0) return 
      
c---------  ---------------------------------------------------      

      CALL TABST (NDIM,KBIF,ISOLV,KHBP,LIMSTEP,NPAR,
     *            STAB,QSOLV,FM,Ystep,YQS,YBIF)

c
c 
      CALL error('Risolve')
c
      close(32)                  
      return
      END

c--------------------------------------------------------------------------------------
c     Tables for results
c
      SUBROUTINE TABST(NDIM,KBIF,KSOL,KHBP,LIMSTEP,NPAR,
     *                 STAB,QSOLV,FM,Ystep,YQS, YBIF)
      implicit integer*4 (i-n)
      implicit real*8 (A-H,O-Z)
	include 'number_equations.fi'
      include 'Param_common.fi'
      common /bifur_turn_steps/ Nbif, Nturn, Nstep 

      REAL*8 YQS (Nturn,NEQ+2)
      REAL*8 YBIF(Nturn,NEQ+2)
                 
      REAL*8   HB(Nbif*2), Ystep(Nstep,NEQ+4)
      REAL*8   ZB(Nbif*2)

	REAL*8    FM(Nparam,NEQ)	!     
	DIMENSION NB(Nbif*2)

      CHARACTER*8  chu, DATE, TIME, Defx(NEQ),Defp(Nparam)

	CHARACTER*35 DATLEN,TIMLEN

      COMMON /Par_Mod/  PCH(Nparam)
       
      DATA DATE/' DATE : '/
      DATA TIME/' TIME : '/

C----------------- OUTPUT the table -------------------
      NP1=NDIM+1

	DO k=1,NDIM
	if(k.lt.10) then
	write(Defx(k),'(a,I1,a)') '  x',k,'    '
	else
      if(k.lt.100) then
	write(Defx(k),'(a,I2,a)') '  x',k,'   '
	else
      if(k.lt.1000) then
	write(Defx(k),'(a,I3,a)') '  x',k,'  '
	else
	write(Defx(k),'(a,I4,a)') '  x',k,' '
	end if
	end if
	end if
	END DO 

	DO k=1,Nparam
	if(k.lt.10) then
	write(Defp(k),'(a,I1,a)') '  p',k,'    '
	else
      if(k.lt.100) then
	write(Defp(k),'(a,I2,a)') '  p',k,'   '
	else
      if(k.lt.1000) then
	write(Defp(k),'(a,I3,a)') '  p',k,'  '
	else
	write(Defp(k),'(a,I4,a)') '  p',k,' '
	end if
	end if
	end if
	END DO 

      open(unit=120,file='stability.dat')
	write(120,998) 'alfa',(Defx(k),k=1,ndim)

	DO J=1,LIMSTEP
	write(120,999) Ystep(J,np1),(Ystep(J,k),k=1,ndim)
	END DO
	close(120)
c

      CALL GETDAT(JY,JM,JD)
      WRITE(DATLEN,'(1X,A,I2.2,1H-,I2.2,1H-,I4.4)') DATE,JD,JM,JY
      call gettim(ih,im,is,is0)
      WRITE(TIMLEN,'(1X,A,I2,A,I2,A,I2)') TIME,ih,':',im,':',is

      OPEN(UNIT=1,FILE='table1.dat')

      WRITE(1,906) DATLEN
      WRITE(1,906) TIMLEN
      WRITE(1,905) '  Table 1. Stationary solutions diagram (st.s.d.))'
      WRITE(1,1112) NPAR 

c
           DO K = 1,LIMSTEP
           IND=NINT(Ystep(K,NP1+1)) 
           WRITE(1,'(/,4x,a,I4)') 'Number of step by current parameter='
     #		 ,K
           WRITE(1,'(4x,a,e15.8)') 'Parameter value   =',Ystep(K,NP1)
           WRITE(1,'(4x,a,I4)') 'Index of current parametter=',IND
           WRITE(1,'(4x,a,e10.3)') 'Determinant value=',
     #		                     Ystep(K,NP1+3)
	     QS=Ystep(K,NP1+2)-STAB
	     if(QS.lt.0.d0) then
	      chu=' STABLE '
           else
	      chu='UNSTABLE'
           end if
           WRITE(1,'(4x,a,a8)') 'Stability: ',chu
           write(1,'(4x,a)') 'Component values:'
           WRITE(1,22) (Ystep(K,J),J=1,NDIM)

           END DO
      write(1,'(/,a,i4)')' Number of steps, N=',limstep
      CLOSE(UNIT=1)
c ----------------------------------------------------------

      OPEN(UNIT=1,FILE='table2.dat')
c ----------------------------------------------------------
      WRITE(1,906) DATLEN
      WRITE(1,906) TIMLEN

	write(1,905) '  Table 2. Spesific points of "turning" type on st.
     &s.d.'
      if(KBIF.gt.0) then
       DO I=1,KBIF
	 Ns=NINT(YBIF(I,NP1+1))
       WRITE(1,'(/,4x,a,I4)') 'Number of turning point:',I
       WRITE(1,'(4x,a,e15.8)') 'Parameter value:',YBIF(I,NP1)
       WRITE(1,'(4x,a,I4)') 'Number of step at the turning point:',Ns
       write(1,'(4x,a)') 'Component values:'
       write(1,22) (YBIF(I,J),J=1,NDIM)
       write(1,115) ('-',k=1,70)
       END DO
      end if
	close(1)

      CALL RESTAB (NP1,LIMSTEP,STAB,KHBP,NB,HB,ZB,Ystep)

      OPEN(UNIT=1,FILE='table3.dat')
      WRITE(1,906) DATLEN
      WRITE(1,906) TIMLEN

	write(1,905) '  Table 3. Points of stability change on st.s.d.'

      if(KHBP.gt.0) then
	DO L=1,KHBP
       WRITE(1,'(/,4x,a,I4)') 'Number of point of stability change:',L
       WRITE(1,'(4x,a,e15.8)') 'Parameter value::',HB(L)
	 if(ZB(L).lt.0.d0) then
	 WRITE(1,'(4x,a)') '(with change of determinant sign)'
	 else
	 WRITE(1,'(4x,a)') '(without change of determinant sign)'
	 end if
       WRITE(1,'(4x,a,I4)') 'Number of step at the point of stability 
     #change:',NB(L)
       write(1,115) ('-',k=1,70)
	END DO
      end if
      close(1)

      OPEN(UNIT=1,FILE='table4.dat')
      WRITE(1,906) DATLEN
      WRITE(1,906) TIMLEN

	write(1,905)'Table 4. Multiplicity solutions and their stability 
     &on st.s.d. '
	write(1,'(5x,a,I4,a,e10.4,/)') 'at the given value of model parame
     &ter p(N)=Qsolv, N=',NPAR,', Qsolv=',qsolv


       if(KSOL.gt.0) then

        DO J=1,KSOL
         QAPPA=YQS(J,NP1+1)
         X=QAPPA-STAB
          if(X.lt.0d0) then
           write(chu,'(a8)') ' STABLE '
          else
           write(chu,'(a8)') 'UNSTABLE'
          end if
          WRITE(1,'(/,4x,a,I4)') 'Number of solution:',J
          WRITE(1,'(4x,a,a8)') 'Stability: ',chu
          write(1,'(4x,a)') 'Component values:'
          write(1,22) (YQS(J,I),I=1,NDIM)
          write(1,115) ('-',k=1,70)
        END DO
       end if
c ----------------------------------------------------------
      CLOSE(UNIT=1)
c
c    
      open(unit=1,file='table5.dat') 
c
      WRITE(1,906) DATLEN
      WRITE(1,906) TIMLEN
	write(1,'(/)')
	write(1,904)'Table 5. Matrix of derivatives of start solution with
     & respect the model parameters (sensitivity matrix)' 
      write(1,'(1x,a,I4,a,I4,a,I4)')
     &                   	'with elements M(i,j)=|dx(j)/dp(i)|, i=1,...
     &,m, m=',Nparam,', j=1,...,n, n=',NDIM,', p(N), N=',NPAR
	write(1,'(/)')
      
	DO J=1,Nparam
	  write(1,999) (FM(J,k),k=1,NDIM)
      END DO  
      
	write(1,'(/,/)')
	write(1,904)'Table 6. Module of maximal derivative in i-th row of 
     &sensitivity matrix,' 
      write(1,'(10x,a,I4)')
     &                   	'max|M(i,j)|=|M(i,j*)|, i=1,...,m, m=',
     &Nparam
	write(1,'(/)')
     
	write(1,115) ('-',k=1,36)     
   
      write(1,'(a)') '   i           j*        |M(i,j*)| '
	write(1,115) ('-',k=1,36)     

	DO J=1,Nparam
	      
	FMAX=0.d0
	imax=1
	DO k=1,NDIM
	if(FMAX.lt.FM(J,k)) then
	FMAX=FM(J,k)
	imax=k
	end if
	END DO
	write(1,'(I4,8X,I4,9X,e10.4)') J,imax,FMAX
	END DO
	write(1,115) ('-',k=1,36)     
      
	write(1,'(/,/)')
	write(1,904)'Table 7. Module of maximal derivative in i-th column  
     &of sensitivity matrix,' 

      write(1,'(10x,a,I4)')
     &                   	'max|M(i,j)|=|M(i*,j)|, j=1,...,n, n=',
     &NDIM
	write(1,'(/)')
     
	write(1,115) ('-',k=1,36)     
   
      write(1,'(a)') '   j           i*        |M(i*,j)| '
	write(1,115) ('-',k=1,36)     

      DO k=1,NDIM
	FMAX=0.d0
	imax=1
	DO J=1,Nparam
	if(FMAX.lt.FM(J,k)) then
	FMAX=FM(J,k)
	imax=J
	end if
	END DO

	write(1,'(I4,8X,I4,9X,e10.4)') k,imax,FMAX

	END DO

	close(1)

22    FORMAT(2X,10e16.8)
115   FORMAT(70a)
1112  FORMAT(5X,'Results of the model parameter continuati
     #on p(N), N=',I4,/)
904   FORMAT(1x,a,/)
905   FORMAT(/,10x,a,/)

906   FORMAT(A)
998   format(6x,a,6x,1000(4x,a8,4x))
997   format(1x,a,1000(4x,a8,4x))
999   format(1000(e16.8))
1000  format(I4,1000(e16.8))
c
c 
      CALL error('Tabst')
c            
      RETURN
      END
c*******************************************************************
    
      subroutine SNEQP(N,NDEX,IPARAM,NEND,LIMIT,LIMIT0,
     *                 IPREDICT,HSTEP,ACCEL,EXACT,EMIN,EMAX,
     *                 NPAR,LIST,KBIF,NSOLV,QSOLV,QMIN,QMAX,
     *                 STAB,U,
     *                 H,YY,
     *                 U1,U2,
     *                 FM,Ystep,ifail,
     *                 YQS,YBIF)
      implicit real*8 (A-H,O-Z)
      implicit integer*4 (i-n)
c
	include 'number_equations.fi'
	include 'param_model.fi'
      common /bifur_turn_steps/ Nbif, Nturn, Nstep
      real*8 YQS (Nturn,NEQ+2)
      REAL*8 YBIF(Nturn,NEQ+2)
c
      REAL*8 B(NEQ,NEQ), Ystep(Nstep,NEQ+4) 
      REAL*8 U00(NEQ),
     *       F  (NEQ+1),
     *       Y1 (NEQ+1),
     *       Y2 (NEQ+1),
     *       W1 (NEQ+1),
     *       W2 (NEQ+1),
     *       H  (N+1),
     *       YY (N+1), 
     *       U(N+1), 
     *       U1(N),
     *       U2(N),
     *       FM(Nparam,NEQ)	
	DIMENSION IA(Nturn) 
      COMMON /ADD_R/ S(Nparam)
	data EPS/2.220446049250313d-016/
c
c---------  Program constants  ------------------------------------
      NP1=N+1
      N0 =N
!!!      EPS=1.d-19
c
      NSOLV=0
      LIST=0
      KBIF=0
      ifail=-1
      JEND=NEND
      ISTART=NDEX
      SGNH=DSIGN(1.d0,HSTEP)

      DO I=1,N
       U00(I)=U(I)
	if(U00(I).lt.U1(I).or.U00(I).gt.U2(I)) ifail=4
      END DO
	if(S(NPAR).lt.QMIN.or.S(NPAR).gt.QMAX) ifail=4
	if(ifail.gt.0) return

c
c     Newton's method
c
      ndex00=ndex
      DO J=1,Nparam
       DO I=1,N
        Y1(I)=U00(I)
       END DO
       Y1(NP1)=S(J)
       ifail0=-1
	 ndex0=ndex00
      CALL NEWTON0 (N,J,ndex0,limit0,exact,ifail0,Y1,Y2,B)
	DO k=1,N
	 FM(J,k)=dabs(Y2(k))
	END DO
	if(J.eq.NPAR) then
       DO I=1,NP1
        U(I)=Y1(I)
	  F(I)=Y2(I)
       END DO
	 ifail=ifail0
	 ndex=ndex0
	end if
	END DO
	
c
      if(ifail.gt.0) return
c
c     Choice of new current parameter on start
c
      IF (IPARAM.EQ.0.OR.IPARAM.EQ.1) THEN
       NN=NP1-IPARAM
       HMAX=0.d0
        DO I=1,NN
         IF(DABS(F(I)).GT.HMAX) THEN
          HMAX=DABS(F(I))
          NDEX=I
         END IF
        END DO

       C9=1.d0/F(NDEX)
       DO I=1,NP1
        F(I)=F(I)*C9
       END DO
      END IF
      GOTO 200
1000  CONTINUE
      CALL NEWTON(N,NPAR,LIST,ndex,limit,ipredict,hstep,H1,
     *            exact,emin,ifail,
     *            H,U1,U2,U,Y1,Y2,W1,W2,F,B) 

      if(ifail.gt.0) return

       W0=W2(NP1)
       F0=F(NP1)
       Y0=Y2(NP1)
       U0=U(NP1)
       LL=DSIGN(1d0,F0)-DSIGN(1d0,W0)
       if(LL.NE.0) then
        CALL BIFUR (N,U,F,Y2,W2,NDEX,LIST,KBIF,DIRECT,YBIF)
       end if
       if(QSOLV.ne.0d0) then
        R1=Y0-QSOLV
        R2=U0-QSOLV
        LL=DSIGN(1d0,R2)-DSIGN(1d0,R1)
        if(LL.NE.0) then
         CALL SOLV_Q(N,U,F,Y2,W2,NDEX,NSOLV,QSOLV,YQS)
         IA(NSOLV)=NDEX
        end if
       end if
c
c      Q in  [QMIN,QMAX] ?
c
       IF(U0.GT.QMAX.OR.U0.LT.QMIN) then
        if(U0.GT.QMAX) then
         QLIMIT=QMAX
        else
         QLIMIT=QMIN
        end if
        HH=U0-Y0
        TT=(QLIMIT-Y0)/HH
        T12=1.d0+2.d0*TT
        T1=1d0-TT
        T2=T1*T1
        T0=TT*TT
        T32=3.d0-2.d0*TT
        DO I=1,N
         FI=F(I)/F0
         WI=W2(I)/W0
         YI=Y2(I)
         RR=YI*T12*T2+U(I)*T32*T0
         U(I)=RR+HH*TT*T1*(T1*WI-TT*FI)
        END DO
        U(NP1)=QLIMIT
        ifail=0
       END IF

200   LIST=LIST+1 

	DO I=1,NP1
	Ystep(LIST,I)=U(I)
	END DO
	Ystep(LIST,N+2)=NDEX

	x00=u(np1)
	S(NPAR)=x00
      CALL PEDERV(N,x00,U,ML,MU,B,N0)
      CALL STABIL (N,B,STAB,QAPPA)
	Ystep(LIST,N+3)=QAPPA

	CALL CALCDET(N,B,DETB)
	Ystep(LIST,N+4)=DETB
c
      if (LIST.EQ.NEND.or.ifail.eq.0)  then
       ifail=0
       goto 100
      end if

      IF(LIST.EQ.1) THEN
c
c    Calculation of step and initial approximation on start
c
      C0=0.d0
      FF=1.d0/F(NDEX)
       DO I=1,NP1
        F2=F(I)*FF
        C0=C0+F2*F2
       END DO
      HSTEP=HSTEP/DSQRT(C0)
      IF(ISTART.EQ.NDEX) GOTO 33
      IF(HSTEP*F(ISTART)*SGNH.GT.0.d0) GOTO 33
      HSTEP=-HSTEP
   33 DIRECT=DSIGN(1d0,HSTEP*F(NP1))
      DO I=1,NP1
       Y2(I)=U(I)
       W2(I)=F(I)
       U(I)=Y2(I)+HSTEP*W2(I)
      END DO

      ELSE
c
c     Choice of new current parameter
c
      IF(IPARAM.LT.2) THEN
c
       NN=NP1-IPARAM
       HMAX=0.d0
        DO I=1,NN
         FMAX=DABS(U(I)-Y2(I)/YY(I))
         IF(FMAX.GT.HMAX) THEN
          HMAX=FMAX
          NDEX=I
         END IF
        END DO
 
       C9=1.d0/F(NDEX)
       DO I=1,NP1
        F(I)=F(I)*C9
       END DO

      END IF
c
c    Calculation of step and initial approximation 
c

         DO I=1,NP1
         Y1(I)=Y2(I)
         W1(I)=W2(I)/W2(NDEX)
         Y2(I)=U(I)
         W2(I)=F(I)
         END DO
c
c     Set of the current step
c
      H1=Y2(NDEX)-Y1(NDEX)
      DIR0=DSIGN(1.d0,H1*F(NP1))
         IF (DIR0.NE.DIRECT) H1=-H1
         HSTEP=ACCEL*H1
            IF (DABS(HSTEP).GT.EMAX*H(NDEX))
     *      HSTEP=EMAX*H(NDEX)*DSIGN(1d0,H1)
c
c    Calculation of initial approximation 
c
         CALL APPROX (N,IPREDICT,HSTEP,H1,U,F,Y1,Y2,W1,W2)
         END IF

      GOTO 1000
 100  CONTINUE
      if (NSOLV.gt.0) then 
         DO J=1,NSOLV
            DO I=1,NP1
            U(I)=YQS(J,I)
            END DO
	   ndex0=IA(J)
         CALL NEWTON0 (N,NPAR,ndex0,limit0,exact,ifail,U,F,B)
         S(NPAR)=QSOLV
         CALL PEDERV(N,QSOLV,U,ML,MU,B,N0)
         CALL STABIL (N,B,STAB,QAPPA)
            DO I=1,N
            YQS(J,I)=U(I)
            END DO
	   YQS(J,NP1+1)=QAPPA
         END DO
      end if
c
c 
      CALL error('Sneqp')
c                  
      RETURN
      END
c--------------------------------------------------------------------------------------
c     Program for study of nonlinear system stability 
c
       SUBROUTINE RESTAB(NP1,LIMSTEP,STAB,KK,NB,HB,ZB,Ystep)
       implicit INTEGER*4 (i-n)
       implicit real*8 (A-H,O-Z)
       include 'number_equations.fi'
	 include 'param_model.fi'
       common /bifur_turn_steps/ Nbif, Nturn, Nstep

	 REAL*8 Ystep(Nstep,NEQ+4)
	 REAL*8 HB(Nbif*2)
	 REAL*8 ZB(Nbif*2)
       DIMENSION NB(Nbif*2)

	 COMMON /ADD_R/ S(Nparam)
c      
	 N=NP1-1
       KK=0
c
        DO LIST=2,LIMSTEP
          x0=Ystep(LIST-1,NP1)
          x1=Ystep(LIST,NP1)
          
		QAPPA1=Ystep(LIST,NP1+2)
          DET1=Ystep(LIST,NP1+3)
          QS1=QAPPA1-STAB

          QAPPA0=Ystep(LIST-1,NP1+2)
          DET0=Ystep(LIST-1,NP1+3)
          QS0=QAPPA0-STAB

          U0=DSIGN(1.d0,QS0)
          D0=DSIGN(1.d0,DET0)
	    
          U1=DSIGN(1.d0,QS1)
          D1=DSIGN(1.d0,DET1)

           if(U0*U1.lt.0.d0) then
            KK=KK+1
	      HB(KK)=x1
	      ZB(KK)=DSIGN(1.d0,D0*D1)
	      NB(KK)=LIST
	     end if
		
        END DO
c
c 
      CALL error('Restab')
c            
       RETURN
       END
c*******************************************************************
c       : , ,      *
c                                                         *
      subroutine APPROX(N,ipredict,hstep,H1,U,F,Y1,Y2,W1,W2)
c
      implicit real*8 (A-H,O-Z)
      implicit integer*4 (i-n)
c
      REAL*8 U(N+1), F(N+1), Y1(N+1), Y2 (N+1), W1(N+1), W2 (N+1)
c
      NP1=N+1
c
c         
c        
c
      SELECT CASE(ipredict)

      CASE(1)
        DO I=1,NP1
         Y2(I)=U(I)
         W2(I)=F(I)
         U(I)=Y2(I)+HSTEP*W2(I)
        END DO

      CASE(2) 
       H0=HSTEP/H1
       HH=H0*H0
          DO I=1,NP1
          FF=Y1(I)-Y2(I)+H1*W2(I)
          U(I)=Y2(I)+HSTEP*W2(I)+FF*HH
          END DO

      CASE(3)
       HH=HSTEP/H1
          DO I=1,NP1
          YH=(Y2(I)-Y1(I))/H1
          F1=W1(I)+W2(I)-2d0*YH
          F2=F1+W2(I)-YH
          U(I)=Y2(I)+HSTEP*(W2(I)+HH*(F2+HH*F1))
          END DO
      END SELECT
c
c 
      CALL error('APPROX')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
	SUBROUTINE BIFUR(N,U,F,Y,W,NDEX,LIST,IBIF,DIRECT,YBIF)
c
      IMPLICIT INTEGER*4 (i-n)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(N+1),U(N+1),W(N+1),F(N+1)
	include 'number_equations.fi'
      common /bifur_turn_steps/ Nbif, Nturn, Nstep 
      REAL*8 YBIF(Nturn,NEQ+2)
	data EPS/2.220446049250313d-016/
c
      NP1=N+1
!!!      EPS=1.D-7
c
      Y0=Y(NP1)
      U0=U(NP1)
      W0=W(NP1)
      F0=F(NP1)

      HH=U(NDEX)-Y(NDEX)

      T1=0.d0
      T2=1.d0
      R1=W0
      R2=F0

   20    IF (T2-T1.LT.EPS.OR.T2.LT.T1) GOTO 10
      T=0.5d0*(T1+T2)
      R0=6.d0*T*(1.d0-T)*(U0-Y0)/HH
      R0=R0+(1.d0-T)*(1.d0-3.d0*T)*W0-T*(2.d0-3.d0*T)*F0
         IF (R0*R2.GT.0d0) GOTO 30
      T1=T
      R1=R0
      GOTO 20
   30 T2=T
      R2=R0
      GOTO 20
   10 CONTINUE
      IBIF=IBIF+1
         DO I=1,NP1
         YI=Y(I)
         WI=W(I)
         UI=U(I)
         FI=F(I)
         RR=YI*(1.d0+2.d0*T)*(1.d0-T)*(1.d0-T)+UI*(3.d0-2.d0*T)*T*T
         YBIF(IBIF,I)=RR+HH*T*(1.d0-T)*((1.d0-T)*WI-T*FI)
         END DO
         YBIF(IBIF,NP1+1)=LIST+1
      DIRECT=-DIRECT
c
c 
      CALL error('BIFUR')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
      SUBROUTINE SOLV_Q(N,U,F,Y,W,NDEX,NSOLV,QSOLV,YQS)
c
      implicit integer*4 (i-n)
      IMPLICIT REAL*8 (A-H,O-Z)
c
      DIMENSION U(N+1),F(N+1),Y(N+1),W(N+1)
	include 'number_equations.fi'
      common /bifur_turn_steps/ Nbif, Nturn, Nstep 
      REAL*8 YQS(Nturn,NEQ+2)
	data EPS/2.220446049250313d-016/
c
      NP1=N+1
!!!      EPS=1.D-7
c
      Y0=Y(NP1)
      W0=W(NP1)
      U0=U(NP1)
      F0=F(NP1)

      R1=Y0-QSOLV
      R2=U0-QSOLV

      HH=U(NDEX)-Y(NDEX)
c
      T1=0.d0
      T2=1.d0

  20  T=0.5d0*(T1+T2)
      T0=1.d0-T
      T00=T0*T0
      T12=1.d0+2.d0*T
      T32=3.d0-2.d0*T
      TT=T*T

      R0=Y0*T12*T00+U0*T32*TT
      R0=R0+HH*T*T0*(T0*W0-T*F0)-QSOLV

      D1=DSIGN(1d0,R0)
      D2=DSIGN(1d0,R2)
         IF (D1-D2.NE.0d0) THEN
         T1=T
         R1=R0
         ELSE
         T2=T
         R2=R0
         END IF

         IF (T2-T1.LT.EPS.OR.T2.LT.T1) GOTO 10
      GOTO 20
   10 NSOLV=NSOLV+1

         DO I=1,N
         YI=Y(I)
         WI=W(I)
         UI=U(I)
         FI=F(I)
         RR=YI*T12*T00+UI*T32*TT
         YQS(NSOLV,I)=RR+HH*T*T0*(T0*WI-T*FI)
         END DO
      YQS(NSOLV,NP1)=QSOLV
c
c 
      CALL error('SOLV_Q')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
      SUBROUTINE GAUSS(N,LG,MG,B,F,IGAUSS,LU_dec)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (i-n)
	include 'number_equations.fi'
      DIMENSION LG(N),MG(N),P(NEQ)
      DIMENSION B(N,N),F(N)
	data EPS/2.220446049250313d-016/
c
      IGAUSS=0
!!!      EPS=1.d-19
c
         IF (LU_dec.EQ.0) GOTO 25
c
      DO K=1,N-1
      C0=0.d+00
         DO I=K,N
            DO J=K,N
               IF (DABS(B(I,J)).LT.DABS(C0)) cycle
               C0=B(I,J)
            L0=I
            LG(K)=I
            M0=J
            MG(K)=J
            END DO
         END DO

         IF (DABS(C0).LT.EPS) THEN
         IGAUSS=1
         return
         END IF 

         DO I=1,N
         P(I)=B(I,M0)
         B(I,M0)=B(I,K)
         B(I,K)=P(I)
         END DO
            DO J=K,N
            P(J)=B(L0,J)
            B(L0,J)=B(K,J)
            END DO
      B(K,K)=C0
         DO J=K+1,N
         B(K,J)=P(J)/C0
             DO I=K+1,N
             B(I,J)=B(I,J)-B(I,K)*B(K,J)
             END DO
         END DO
      END DO

         IF(DABS(B(N,N)).LT.EPS) THEN
         IGAUSS=1
         return
         END IF
   25 CONTINUE
         DO K=1,N-1
         LK=LG(K)
         F0=F(LK)
         F(LK)=F(K)
         F(K)=F0/B(K,K)
         KK=K+1
            DO I=KK,N
            F(I)=F(I)-B(I,K)*F(K)
            END DO
         END DO

      F(N)=F(N)/B(N,N)

         DO K=N-1,1,-1
         KK=K+1
            DO J=N,KK,-1
            F(K)=F(K)-B(K,J)*F(J)
            END DO
          END DO

         DO K=N-1,1,-1
         MK=MG(K)
         F0=F(MK)
         F(MK)=F(K)
         F(K)=F0
         END DO
c
c 
      CALL error('GAUSS')
c                     
      RETURN
      END
c--------------------------------------------------------------------------------------
c*******************************************************************
c                        *
c                                           *
c                                                                  *
      subroutine NEWTON0 (N,NPAR,ndex,limit0,exact,ifail,U,F,B)
c
      implicit real*8 (A-H,O-Z)
      implicit integer*4 (i-n)
c
      REAL*8 B(N,N)
	include 'number_equations.fi'
	include 'param_model.fi'
      REAL*8 U(N+1), F(N+1)
      DIMENSION LG (NEQ), MG (NEQ), V(NEQ), CL(NEQ)
      COMMON /ADD_R/ S(Nparam)
	data EPS/2.220446049250313d-016/

c---------     ------------------------------------
      NP1=N+1
      N0=N
!!!      EPS=1.d-19
      ifail=-1
c
c        
c
      ITER=0
 1001 ITER=ITER+1
c
c      
c      .  
c     
c
       S(NPAR)=U(NP1)
       CALL PEDERV(N,X,U,ML,MU,B,N0)
       CALL COLUM_Q(N,NPAR,U,CL)
       CALL DIFFUN (N,X,U,F)
c
      if(ndex.le.N) then 
        DO I=1,N
         V(I)=B(I,ndex)
         B(I,ndex)=CL(I)
        END DO
      else
	  DO I=1,N
         V(I)=CL(I)
        END DO
	end if
c
      DO I=1,N
        BMAX=0d0
        DO K=1,N
         BMAX=DMAX1(BMAX,DABS(B(I,K)))
        END DO
        IF(BMAX.LT.EPS) BMAX=EPS
        CL(I)=BMAX
         DO K=1,N
          B(I,K)=B(I,K)/BMAX
         END DO
        F(I)=F(I)/BMAX
      END DO
c
c       -- C0
c
      CALL GAUSS(N,LG,MG,B,F,IGAUSS,1)
c
      IF(IGAUSS.EQ.1) THEN
        ifail=1 !    !
        RETURN
      END IF
 
       C0=0d0
       C1=0d0
        DO I=1,N
         C0=DMAX1(C0,DABS(F(I)))
         C1=DMAX1(C1,DABS(U(I)))
        END DO
        IF(C1.GT.1d0) C0=C0/C1

      F(NP1)=F(ndex)
      F(ndex)=0d0

      DO I=1,NP1
         U(I)=U(I)-F(I)
      END DO
c
c          
c
      IF(C0.LT.EXACT) GOTO 200 !!!    !

      if(ITER.LT.LIMIT0) then
        GOTO 1001
      else
        ifail=2 !
        RETURN
      end if

200   CONTINUE
c
c         
c
      DO I=1,N
       F(I)=-V(I)/CL(I)
      END DO
c
      CALL GAUSS(N,LG,MG,B,F,IGAUSS,0)
c
      F(NP1)=F(ndex)
      F(ndex)=1d0
c
c 
      CALL error('NEWTON0')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
c*******************************************************************
c                                 *
c                                                                  *
      subroutine NEWTON(N,NPAR,LIST,ndex,limit,ipredict,hstep,
     *                  H1,exact,emin,ifail,
     *                  H,U1,U2,U,Y1,Y2,W1,W2,F,B) 
c
      implicit real*8 (A-H,O-Z)
      implicit integer*4 (i-n)
c
      REAL*8 B(N,N)
	include 'number_equations.fi'
	include 'param_model.fi'
      REAL*8 U1(N), U2(N), U(N+1), H(N+1), F(N+1), Y1(N+1), Y2(N+1), 
     *       W1(N+1), W2(N+1)
      DIMENSION LG (NEQ), MG(NEQ), V(NEQ), CL(NEQ)
      COMMON /ADD_R/   S(Nparam)
	data EPS/2.220446049250313d-016/
c---------     ------------------------------------
      NP1=N+1
      N0=N
!!!      EPS=1.d-19
c
c        
c
 1000 ITER=0
 1001 ITER=ITER+1
c
c     
c      
c
      DO I=1,N
       IF (U(I).LT.U1(I).OR.U(I).GT.U2(I)) GOTO 14
      END DO
c
c      
c      .  
c     
c
       S(NPAR)=U(NP1)
       CALL PEDERV(N,X,U,ML,MU,B,N0)
       CALL COLUM_Q(N,NPAR,U,CL)
       CALL DIFFUN (N,X,U,F)
c
      if(ndex.le.N) then 
        DO I=1,N
         V(I)=B(I,ndex)
         B(I,ndex)=CL(I)
        END DO
      else
	  DO I=1,N
         V(I)=CL(I)
        END DO
	end if
c
      DO I=1,N
        BMAX=0d0
        DO K=1,N
         BMAX=DMAX1(BMAX,DABS(B(I,K)))
        END DO
        IF(BMAX.LT.EPS) BMAX=EPS
        CL(I)=BMAX
         DO K=1,N
          B(I,K)=B(I,K)/BMAX
         END DO
        F(I)=F(I)/BMAX
      END DO
c
c      
c
      CALL GAUSS(N,LG,MG,B,F,IGAUSS,1)
c
      IF(IGAUSS.EQ.1) GOTO 14
 
       C0=0d0
       C1=0d0
        DO I=1,N
         C0=DMAX1(C0,DABS(F(I)))
         C1=DMAX1(C1,DABS(U(I)))
        END DO
        IF(C1.GT.1d0) C0=C0/C1

      F(NP1)=F(NDEX)
      F(NDEX)=0d0

      DO I=1,NP1
         U(I)=U(I)-F(I)
      END DO
c
c          
c
      IF(C0.LT.EXACT) GOTO 200 !    !
      IF(ITER.LT.LIMIT) GOTO 1001
c
c
c        HSTEP 
c
   14 HSTEP=5.d-1*HSTEP
      IF(DABS(HSTEP).LT.EMIN*H(NDEX)) THEN
         ifail=3
         RETURN
      END IF
c
      IF(LIST.EQ.1) THEN
       DO I=1,NP1
        U(I)=Y2(I)+HSTEP*W2(I)
       END DO
      ELSE
c
c         
c        
c
      CALL APPROX (N,ipredict,hstep,H1,U,F,Y1,Y2,W1,W2)
      END IF
      GOTO 1000
c
c         
c
200   CONTINUE
      DO I=1,N
       F(I)=-V(I)/CL(I)
      END DO
c
      CALL GAUSS(N,LG,MG,B,F,IGAUSS,0)
c
      F(NP1)=F(NDEX)
      F(NDEX)=1d0
c
c 
      CALL error('NEWTON')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
c    -   
c
      SUBROUTINE STABIL(N,A,STAB,QAPPA)
      IMPLICIT REAL*8(A-H,O-Z)
      implicit integer*4 (i-n) 
      include 'number_equations.fi'
c
      DIMENSION A(N,N)
c
      DIMENSION Q (NEQ,NEQ),
     *          E (NEQ,NEQ),
     *          S (NEQ,NEQ),
     *          T (NEQ,NEQ),
     *          R (NEQ,NEQ)
	data DEPS/2.220446049250313d-016/
	data ERSTAB/2.220446049250313d-016/
c
!!!      DEPS=1.D-7
      N1=20
      N2=20
      N3=40
!!!      ERSTAB=1.d-10
      L=1
      ANORM=0d0
c
        DO I=1,N
        SUMMA=0d0
         DO J=1,N
         SUMMA=SUMMA+DABS(A(I,J))
         T(I,J)=0.d0
         E(I,J)=0.d0
         END DO
        IF(ANORM.LT.SUMMA) ANORM=SUMMA
        T(I,I)=1d0
        E(I,I)=1d0
        END DO
      A1=1d0/ANORM
      DO  I=1,N
      DO  J=1,N
      S(I,J)=A(I,J)*A1
      END DO
      END DO
   11 CONTINUE
      A2=1d0/L
      ANORM=0.d0
       DO I=1,N
       SUMMA=0d0
        DO J=1,N
      SMULT=0d0
       DO M=1,N
       SMULT=SMULT+S(I,M)*T(M,J)
       END DO
      SUMMA=SUMMA+DABS(SMULT)
        R(I,J)=A2*SMULT
        E(I,J)=E(I,J)+R(I,J)
        END DO
       IF(ANORM.LT.SUMMA) ANORM=SUMMA
       END DO
C
      DO I=1,N
      DO J=1,N
      T(I,J)=R(I,J)
      END DO
      END DO
C
      IF(ANORM.LT.DEPS.OR.L.EQ.N1) GOTO 10
      L=L+1
      GOTO 11
C
   10   L=1
       DO I=1,N
         DO J=1,N
         Q(I,J)=0d0
         R(I,J)=0d0
         END DO
       Q(I,I)=1d0
       R(I,I)=1d0
       END DO
C
   20 CONTINUE
       ANORM=0d0
       A2=1d0/(L+1)
       DO I=1,N
       SUMMA=0d0
        DO J=1,N
      SM1=0d0
      SM2=0d0
         DO M=1,N
          SM1=SM1+Q(I,M)*S(M,J)
          SM2=SM2+S(M,I)*Q(M,J)
        END DO
      SUMMA=SUMMA+DABS(SM2)
      T(I,J)=(SM1+SM2)*A2
      R(I,J)=R(I,J)+T(I,J)
      END DO
       IF(ANORM.LT.SUMMA) ANORM=SUMMA
       END DO
C
      DO I=1,N
         DO J=1,N
         Q(I,J)=T(I,J)
         END DO
      END DO
C
      IF(ANORM.LT.DEPS.OR.L.EQ.N2) GOTO 25
      L=L+1
      GOTO 20
C
   25 N0=DLOG(STAB*DLOG(2d0*DSQRT(STAB)))/DLOG(2d0)
      N4=N3+N0
      L=1
      QAPP0=0d0
      DO I=1,N
         DO J=1,N
         Q(I,J)=E(I,J)
         END DO
      END DO
   21    CONTINUE
         DO I=1,N
           DO J=1,N
         SMULT=0d0
          DO M=1,N
            SMULT=SMULT+R(I,M)*Q(M,J)
          END DO
          T(I,J)=SMULT
          END DO
      END DO
C
      ANORM=0d0
       DO I=1,N
       SUMMA=0d0
        DO J=1,N
      SMULT=0d0
       DO M=1,N
       SMULT=SMULT+Q(M,I)*T(M,J)
       END DO
      R(I,J)=R(I,J)+SMULT
      SUMMA=SUMMA+DABS(R(I,J))
      END DO
       IF(ANORM.LT.SUMMA) ANORM=SUMMA
       END DO
C
      QAPPA=ANORM+ANORM
      DELTA=DABS(QAPPA-QAPP0)/QAPPA
      IF(QAPPA.GT.STAB.OR.L.EQ.N4.OR.DELTA.LT.ERSTAB)GOTO 35
      ANORM=0d0
      DO I=1,N
        SUMMA=0d0
        DO J=1,N
      SMULT=0d0
       DO M=1,N
       SMULT=SMULT+Q(I,M)*Q(M,J)
       END DO
      SUMMA=SUMMA+DABS(SMULT)
      E(I,J)=SMULT
      END DO
       IF(ANORM.LT.SUMMA) ANORM=SUMMA
       END DO
      DO I=1,N
        DO J=1,N
        Q(I,J)=E(I,J)
      END DO
      END DO
      L=L+1
      QAPP0=QAPPA
      GOTO 21
   35 CONTINUE
c
c 
      CALL error('STABIL')
c            
      RETURN
      END
c--------------------------------------------------------------------------------------
c       
c
      SUBROUTINE CALCDET(N,B,DETB)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*4 (i-n)
	include 'number_equations.fi'
      DIMENSION LG(NEQ),MG(NEQ),P(NEQ)
      DIMENSION B(N,N)
c-----------------------------------------------------------
      DO K=1,N-1
       C0=0d0
       DO I=K,N
        DO J=K,N
         IF(DABS(B(I,J)).LT.DABS(C0)) cycle
          C0=B(I,J)
          L0=I
          LG(K)=I
          M0=J
          MG(K)=J
        END DO
       END DO
c
       DO I=1,N
        P(I)=B(I,M0)
        B(I,M0)=B(I,K)
        B(I,K)=P(I)
       END DO
       DO J=K,N
        P(J)=B(L0,J)
        B(L0,J)=B(K,J)
       END DO
       B(K,K)=C0
        KK=K+1
        DO J=KK,N
         B(K,J)=P(J)/C0
           DO I=KK,N
            B(I,J)=B(I,J)-B(I,K)*B(K,J)
           END DO
        END DO
      END DO
c-----------------------------------------------------------
      BN=B(N,N)
      D0=DSIGN(1.d0,BN)
      DETB=DLOG(DABS(BN))
      DO I=1,N-1
       BI=B(I,I)
       IF(LG(I).NE.I) D0=-D0
       IF(MG(I).NE.I) D0=-D0
       IF(DSIGN(1.d0,BI).LT.0d0) D0=-D0
       DETB=DETB+DLOG(DABS(BI))
      END DO
      DETB=D0*DEXP(DETB)
c
c 
      CALL error('CALCDET')
c            
      RETURN
      END